%% Problem2a
% INPUT
% a - Point in R^2
% p, q - Vectors specifying the line G
% OUTPUT
% aReflect - Reflection of a thru G

function [aReflect] = Problem2a(a, p, q)

% Computing the reflection point
alpha = dot(a-p,q)/(dot(q,q));
aReflect = 2*(p+q*alpha) - a;

% Plotting
figure(1) % Oeffnet Plotfenster
% Plot the line G
plot([p(1)+(alpha-10)*q(1); p(1)+(alpha+10)*q(1)], ... %Zeilenumbruch
    [p(2)+(alpha-10)*q(2); p(2)+(alpha+10)*q(2)], 'r-');

% Folgende Plotkommandos erscheinen im gleichen Fenster
hold on;

% Plotting a
plot(a(1), a(2), 'bo', 'LineWidth', 1.5)

% Plotting reflection point
plot(aReflect(1), aReflect(2), 'b+', 'LineWidth', 1.5)

% Plotting the line connecting a with its reflection
plot([a(1); aReflect(1)], [a(2); aReflect(2)], 'b--');

legend('Line G','Point a','Reflection of a');
title('Problem 2(a)');
axis equal
end
